'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _find = require('lodash/find');

var _find2 = _interopRequireDefault(_find);

var _utils = require('../utils');

var _label = require('../label');

var _label2 = _interopRequireDefault(_label);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormItem = _antd.Form.Item;
var Group = _antd.Checkbox.Group;

var FormCheckboxGroup = function FormCheckboxGroup(_ref) {
  var id = _ref.id,
      init = _ref.init,
      options = _ref.options,
      optionValue = _ref.optionValue,
      onChange = _ref.onChange,
      optionLabel = _ref.optionLabel,
      showRequired = _ref.showRequired,
      required = _ref.required,
      editable = _ref.editable,
      labelCol = _ref.labelCol,
      wrapperCol = _ref.wrapperCol,
      label = _ref.label,
      form = _ref.form;

  var newOptions = options || [];
  var rules = [];
  if (required) {
    rules.push(_utils.validation.validRequired());
  }

  var getLabel = function getLabel(option) {
    if (typeof optionLabel === 'function') {
      return optionLabel(option);
    }
    return option[optionLabel || 'label'];
  };

  if (editable === false) {
    // let obj = find(options, o => o[optionValue || 'value'] === init)
    var objs = [];

    var _loop = function _loop(i) {
      var obj = (0, _find2.default)(newOptions, function (o) {
        return o[optionValue || 'value'] === init[i];
      });
      if (obj) {
        objs.push(getLabel(obj));
      }
    };

    for (var i = 0; i < init.length; i++) {
      _loop(i);
    }
    return _react2.default.createElement(
      FormItem,
      {
        label: label,
        labelCol: labelCol,
        wrapperCol: wrapperCol,
        required: required && showRequired
      },
      _react2.default.createElement(
        _label2.default,
        null,
        objs.join(',') || init
      )
    );
  }
  var groupOptions = [];
  for (var i = 0; i < newOptions.length; i++) {
    groupOptions.push({
      value: newOptions[i][optionValue || 'value'],
      label: getLabel(newOptions[i])
    });
  }
  var getFieldDecorator = form.getFieldDecorator;

  return _react2.default.createElement(
    FormItem,
    {
      label: label,
      labelCol: labelCol,
      wrapperCol: wrapperCol,
      required: required && showRequired
    },
    getFieldDecorator(id, {
      initialValue: init,
      rules: rules,
      onChange: onChange
    })(_react2.default.createElement(Group, { options: groupOptions }))
  );
};

exports.default = FormCheckboxGroup;