'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

require('antd/lib/form/style/css');

var _datePicker = require('antd/lib/date-picker');

var _datePicker2 = _interopRequireDefault(_datePicker);

require('antd/lib/date-picker/style/css');

var _utils = require('../utils');

var _label = require('../label');

var _label2 = _interopRequireDefault(_label);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }
// import { Form, DatePicker } from 'antd';


var FormItem = _form2.default.Item;
var FormDatePicker = function FormDatePicker(_ref) {
  var id = _ref.id,
      init = _ref.init,
      rules = _ref.rules,
      required = _ref.required,
      validateStatus = _ref.validateStatus,
      help = _ref.help,
      showRequired = _ref.showRequired,
      labelCol = _ref.labelCol,
      wrapperCol = _ref.wrapperCol,
      editable = _ref.editable,
      label = _ref.label,
      form = _ref.form,
      datePickerPorps = _objectWithoutProperties(_ref, ['id', 'init', 'rules', 'required', 'validateStatus', 'help', 'showRequired', 'labelCol', 'wrapperCol', 'editable', 'label', 'form']);

  if (editable === false) {
    return _react2.default.createElement(
      FormItem,
      { label: label, labelCol: labelCol, wrapperCol: wrapperCol },
      _react2.default.createElement(
        _label2.default,
        null,
        init ? init.format(datePickerPorps.format || 'YYYY-MM-DD') : null
      )
    );
  }
  rules = rules || [];
  if (required) {
    rules.push(_utils.validation.validRequired());
  }
  var getFieldDecorator = form.getFieldDecorator;

  return _react2.default.createElement(
    FormItem,
    {
      label: label,
      labelCol: labelCol,
      wrapperCol: wrapperCol,
      required: showRequired,
      validateStatus: validateStatus,
      help: help
    },
    getFieldDecorator(id, {
      initialValue: init,
      rules: rules
    })(_react2.default.createElement(_datePicker2.default, datePickerPorps))
  );
};

exports.default = FormDatePicker;