'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

require('antd/lib/form/style/css');

var _inputNumber = require('antd/lib/input-number');

var _inputNumber2 = _interopRequireDefault(_inputNumber);

require('antd/lib/input-number/style/css');

var _label = require('../label');

var _label2 = _interopRequireDefault(_label);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }
// import { Form } from 'antd';


var FormItem = _form2.default.Item;
var FormInputNumber = function FormInputNumber(_ref) {
  var id = _ref.id,
      init = _ref.init,
      required = _ref.required,
      showRequired = _ref.showRequired,
      maxLength = _ref.maxLength,
      specialChar = _ref.specialChar,
      labelCol = _ref.labelCol,
      wrapperCol = _ref.wrapperCol,
      label = _ref.label,
      editable = _ref.editable,
      form = _ref.form,
      help = _ref.help,
      minValue = _ref.minValue,
      maxValue = _ref.maxValue,
      inputPorps = _objectWithoutProperties(_ref, ['id', 'init', 'required', 'showRequired', 'maxLength', 'specialChar', 'labelCol', 'wrapperCol', 'label', 'editable', 'form', 'help', 'minValue', 'maxValue']);

  if (editable === false) {
    return _react2.default.createElement(
      FormItem,
      { label: label, labelCol: labelCol, wrapperCol: wrapperCol },
      _react2.default.createElement(
        _label2.default,
        null,
        init
      )
    );
  }
  var rules = [];
  if (required) {
    rules.push(_utils.validation.validRequired());
  }
  if (maxLength > 0) {
    rules.push(_utils.validation.validMax(maxLength));
  }
  if (specialChar) {
    rules.push(_utils.validation.validSpecialChar());
  }
  if (minValue !== undefined && maxValue === undefined) {
    rules.push(_utils.validation.validRange(minValue));
  }
  if (maxValue !== undefined && minValue === undefined) {
    rules.push(_utils.validation.validRange(undefined, maxValue));
  }
  if (maxValue !== undefined && minValue !== undefined) {
    rules.push(_utils.validation.validRange(minValue, maxValue));
  }
  var getFieldDecorator = form.getFieldDecorator;

  return _react2.default.createElement(
    FormItem,
    {
      label: label,
      labelCol: labelCol,
      wrapperCol: wrapperCol,
      help: help,
      required: inputPorps.editable && required && showRequired
    },
    getFieldDecorator(id, {
      initialValue: init,
      rules: rules
    })(_react2.default.createElement(_inputNumber2.default, inputPorps))
  );
};

exports.default = FormInputNumber;