'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

require('antd/lib/form/style/css');

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

require('antd/lib/input/style/css');

var _label = require('../label');

var _label2 = _interopRequireDefault(_label);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }
// import { Form } from 'antd';


var FormItem = _form2.default.Item;
var FormInput = function FormInput(_ref) {
  var id = _ref.id,
      init = _ref.init,
      required = _ref.required,
      showRequired = _ref.showRequired,
      rules = _ref.rules,
      url = _ref.url,
      idCard = _ref.idCard,
      max = _ref.max,
      phone = _ref.phone,
      telephone = _ref.telephone,
      numberAndLetter = _ref.numberAndLetter,
      email = _ref.email,
      specialChar = _ref.specialChar,
      ip = _ref.ip,
      labelCol = _ref.labelCol,
      wrapperCol = _ref.wrapperCol,
      label = _ref.label,
      form = _ref.form,
      editable = _ref.editable,
      help = _ref.help,
      inputPorps = _objectWithoutProperties(_ref, ['id', 'init', 'required', 'showRequired', 'rules', 'url', 'idCard', 'max', 'phone', 'telephone', 'numberAndLetter', 'email', 'specialChar', 'ip', 'labelCol', 'wrapperCol', 'label', 'form', 'editable', 'help']);

  if (editable === false) {
    return _react2.default.createElement(
      FormItem,
      { label: label, labelCol: labelCol, wrapperCol: wrapperCol },
      _react2.default.createElement(
        _label2.default,
        null,
        init
      )
    );
  }
  rules = rules || [];
  if (required) {
    rules.push(_utils.validation.validRequired());
  }
  if (max > 0) {
    rules.push(_utils.validation.validMax(max));
  }
  if (specialChar) {
    rules.push(_utils.validation.validSpecialChar());
  }
  if (phone) {
    rules.push(_utils.validation.validPhone());
  }
  if (telephone) {
    rules.push(_utils.validation.validTelephone());
  }
  if (idCard) {
    rules.push(_utils.validation.validIDCard());
  }
  if (email) {
    rules.push(_utils.validation.validEmail());
  }
  if (numberAndLetter) {
    rules.push(_utils.validation.validNumAndLetter());
  }
  if (url) {
    rules.push(_utils.validation.validUrl());
  }
  if (ip) {
    rules.push(_utils.validation.validIP());
  }
  // getFieldDecorator不能装饰纯函数组件
  var getFieldDecorator = form.getFieldDecorator;

  return _react2.default.createElement(
    FormItem,
    {
      label: label,
      labelCol: labelCol,
      wrapperCol: wrapperCol,
      help: help,
      required: inputPorps.editable && required && showRequired
    },
    getFieldDecorator(id, {
      initialValue: init,
      rules: rules
    })(_react2.default.createElement(_input2.default, _extends({ autoComplete: 'off' }, inputPorps)))
  );
};

exports.default = FormInput;