'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

require('antd/lib/form/style/css');

var _radio = require('antd/lib/radio');

var _radio2 = _interopRequireDefault(_radio);

require('antd/lib/radio/style/css');

var _find = require('lodash/find');

var _find2 = _interopRequireDefault(_find);

var _utils = require('../utils');

var _label = require('../label');

var _label2 = _interopRequireDefault(_label);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }
// import { Form, Radio } from 'antd';


var FormItem = _form2.default.Item;
var RadioButton = _radio2.default.Button;
var RadioGroup = _radio2.default.Group;
var FormRadioButton = function FormRadioButton(_ref) {
  var id = _ref.id,
      init = _ref.init,
      options = _ref.options,
      showRequired = _ref.showRequired,
      required = _ref.required,
      editable = _ref.editable,
      labelCol = _ref.labelCol,
      wrapperCol = _ref.wrapperCol,
      label = _ref.label,
      onChange = _ref.onChange,
      form = _ref.form,
      radioPorps = _objectWithoutProperties(_ref, ['id', 'init', 'options', 'showRequired', 'required', 'editable', 'labelCol', 'wrapperCol', 'label', 'onChange', 'form']);

  if (editable === false) {
    var obj = (0, _find2.default)(options, function (o) {
      return o.value === init;
    });
    return _react2.default.createElement(
      FormItem,
      {
        label: label,
        labelCol: labelCol,
        wrapperCol: wrapperCol,
        required: required && showRequired
      },
      _react2.default.createElement(
        _label2.default,
        null,
        obj ? obj.label : init
      )
    );
  }
  options = options || [];
  var rules = [];
  if (required) {
    rules.push(_utils.validation.validRequired());
  }
  var getFieldDecorator = form.getFieldDecorator;

  return _react2.default.createElement(
    FormItem,
    {
      label: label,
      labelCol: labelCol,
      wrapperCol: wrapperCol,
      required: required && showRequired
    },
    getFieldDecorator(id, {
      initialValue: init,
      rules: rules,
      onChange: onChange
    })(_react2.default.createElement(
      RadioGroup,
      radioPorps,
      options.map(function (option, index) {
        return _react2.default.createElement(
          RadioButton,
          {
            key: index,
            value: option.value
          },
          option.label
        );
      })
    ))
  );
};

exports.default = FormRadioButton;