'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

require('antd/lib/form/style/css');

var _select = require('antd/lib/select');

var _select2 = _interopRequireDefault(_select);

require('antd/lib/select/style/css');

var _find = require('lodash/find');

var _find2 = _interopRequireDefault(_find);

var _utils = require('../utils');

var _label = require('../label');

var _label2 = _interopRequireDefault(_label);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }
// import { Form, Select } from 'antd';


var FormItem = _form2.default.Item;
var FormSelect = function FormSelect(_ref) {
  var id = _ref.id,
      init = _ref.init,
      options = _ref.options,
      optionValue = _ref.optionValue,
      onChange = _ref.onChange,
      optionLabel = _ref.optionLabel,
      showRequired = _ref.showRequired,
      required = _ref.required,
      editable = _ref.editable,
      labelCol = _ref.labelCol,
      wrapperCol = _ref.wrapperCol,
      label = _ref.label,
      extra = _ref.extra,
      form = _ref.form,
      help = _ref.help,
      selectPorps = _objectWithoutProperties(_ref, ['id', 'init', 'options', 'optionValue', 'onChange', 'optionLabel', 'showRequired', 'required', 'editable', 'labelCol', 'wrapperCol', 'label', 'extra', 'form', 'help']);

  var newOptions = options || [];
  var getLabel = function getLabel(option) {
    if (typeof optionLabel === 'function') {
      return optionLabel(option);
    }
    return option[optionLabel || 'label'];
  };

  if (editable === false) {
    // let obj = find(options, o => o[optionValue || 'value'] === init)
    var obj = null;
    if (selectPorps.labelInValue) {
      obj = (0, _find2.default)(newOptions, function (o) {
        return o[optionValue || 'value'] === init.key;
      });
    } else {
      obj = (0, _find2.default)(newOptions, function (o) {
        return o[optionValue || 'value'] === init;
      });
    }
    return _react2.default.createElement(
      FormItem,
      {
        label: label,
        labelCol: labelCol,
        wrapperCol: wrapperCol,
        help: help,
        required: required && showRequired
      },
      _react2.default.createElement(
        _label2.default,
        null,
        obj ? getLabel(obj) : init
      )
    );
  }
  var rules = [];
  if (required) {
    rules.push(_utils.validation.validRequired());
  }
  var getFieldDecorator = form.getFieldDecorator;

  return _react2.default.createElement(
    FormItem,
    {
      label: label,
      labelCol: labelCol,
      wrapperCol: wrapperCol,
      required: required && showRequired,
      extra: extra
    },
    getFieldDecorator(id, {
      initialValue: init,
      rules: rules,
      onChange: onChange
    })(_react2.default.createElement(
      _select2.default,
      selectPorps,
      newOptions.map(function (option) {
        return _react2.default.createElement(
          _select2.default.Option,
          { key: option[optionValue || 'value'].toString(), value: option[optionValue || 'value'].toString() },
          getLabel(option)
        );
      })
    ))
  );
};

exports.default = FormSelect;