'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

require('antd/lib/form/style/css');

var _switch = require('antd/lib/switch');

var _switch2 = _interopRequireDefault(_switch);

require('antd/lib/switch/style/css');

var _label = require('../label');

var _label2 = _interopRequireDefault(_label);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }
// import { Form, Switch } from 'antd';


var FormItem = _form2.default.Item;
var FormSwitch = function FormSwitch(_ref) {
  var id = _ref.id,
      init = _ref.init,
      required = _ref.required,
      showRequired = _ref.showRequired,
      labelCol = _ref.labelCol,
      wrapperCol = _ref.wrapperCol,
      editable = _ref.editable,
      label = _ref.label,
      form = _ref.form,
      switchPorps = _objectWithoutProperties(_ref, ['id', 'init', 'required', 'showRequired', 'labelCol', 'wrapperCol', 'editable', 'label', 'form']);

  if (editable === false) {
    return _react2.default.createElement(
      FormItem,
      { label: label, labelCol: labelCol, wrapperCol: wrapperCol },
      _react2.default.createElement(
        _label2.default,
        null,
        init ? switchPorps.checkedChildren : switchPorps.unCheckedChildren
      )
    );
  }
  var rules = [];
  if (required) {
    rules.push(_utils.validation.validRequired());
  }
  var getFieldDecorator = form.getFieldDecorator;

  return _react2.default.createElement(
    FormItem,
    { label: label, labelCol: labelCol, wrapperCol: wrapperCol, required: showRequired },
    getFieldDecorator(id, {
      initialValue: init,
      valuePropName: 'checked',
      rules: rules
    })(_react2.default.createElement(_switch2.default, switchPorps))
  );
};

exports.default = FormSwitch;