'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

require('antd/lib/form/style/css');

var _textarea = require('../textarea');

var _textarea2 = _interopRequireDefault(_textarea);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }
// import { Form } from 'antd';


var FormItem = _form2.default.Item;
var FormTextarea = function FormTextarea(_ref) {
  var id = _ref.id,
      init = _ref.init,
      required = _ref.required,
      showRequired = _ref.showRequired,
      rules = _ref.rules,
      url = _ref.url,
      idCard = _ref.idCard,
      max = _ref.max,
      phone = _ref.phone,
      telephone = _ref.telephone,
      email = _ref.email,
      specialChar = _ref.specialChar,
      labelCol = _ref.labelCol,
      wrapperCol = _ref.wrapperCol,
      label = _ref.label,
      getFieldDecorator = _ref.form.getFieldDecorator,
      inputPorps = _objectWithoutProperties(_ref, ['id', 'init', 'required', 'showRequired', 'rules', 'url', 'idCard', 'max', 'phone', 'telephone', 'email', 'specialChar', 'labelCol', 'wrapperCol', 'label', 'form']);

  rules = rules || [];
  if (required) {
    rules.push(_utils.validation.validRequired());
  }
  if (max > 0) {
    rules.push(_utils.validation.validMax(max));
  }
  if (specialChar) {
    rules.push(_utils.validation.validSpecialChar());
  }
  if (phone) {
    rules.push(_utils.validation.validPhone());
  }
  if (idCard) {
    rules.push(_utils.validation.validIDCard());
  }
  if (email) {
    rules.push(_utils.validation.validEmail());
  }
  if (url) {
    rules.push(_utils.validation.validUrl());
  }
  if (telephone) {
    rules.push(_utils.validation.validTelephone());
  }
  // getFieldDecorator不能装饰纯函数组件
  return _react2.default.createElement(
    FormItem,
    {
      label: label,
      labelCol: labelCol,
      wrapperCol: wrapperCol,
      required: inputPorps.editable && required && showRequired
    },
    getFieldDecorator(id, {
      initialValue: init,
      rules: rules
    })(_react2.default.createElement(_textarea2.default, inputPorps))
  );
};

exports.default = FormTextarea;