'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _tree = require('antd/lib/tree');

var _tree2 = _interopRequireDefault(_tree);

require('antd/lib/tree/style/css');

var _spin = require('antd/lib/spin');

var _spin2 = _interopRequireDefault(_spin);

require('antd/lib/spin/style/css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }
// import { Tree, Spin } from 'antd';


var TreeNode = _tree2.default.TreeNode;

var DDTree = function DDTree(_ref) {
  var selectTree = _ref.selectTree,
      dataSource = _ref.dataSource,
      title = _ref.title,
      _onSelect = _ref.onSelect,
      loading = _ref.loading,
      treeProps = _objectWithoutProperties(_ref, ['selectTree', 'dataSource', 'title', 'onSelect', 'loading']);

  selectTree = selectTree || {};
  dataSource = dataSource || [];
  // // 产生keys
  // const genKeys = (prefix, nodes) => {
  //   for (let i = 0; i < nodes.length; i++) {
  //     nodes[i].key = `${prefix}-${i}`
  //     genKeys(nodes[i].key, nodes[i].children)
  //   }
  // }
  // genKeys(dataSource)
  var getTitle = function getTitle(item) {
    if (typeof title === 'function') {
      return title(item);
    }
    return item[title || 'title'];
  };
  var genTreeNodes = function genTreeNodes(data) {
    return data.map(function (item) {
      if (item.children) {
        return _react2.default.createElement(
          TreeNode,
          { title: getTitle(item), disabled: item.disabled, key: '' + item.key },
          genTreeNodes(item.children)
        );
      }
      return _react2.default.createElement(TreeNode, { title: getTitle(item), disabled: item.disabled, key: '' + item.key });
    });
  };
  var getTreeKeys = function getTreeKeys(nodes) {
    if (!nodes || nodes.length === 0) {
      return [];
    }
    var keys = [];
    nodes.forEach(function (node) {
      keys.push(node.key);
      var childKeys = getTreeKeys(node.children);
      if (childKeys && childKeys.length > 0) {
        childKeys.forEach(function (child) {
          return keys.push(child);
        });
      }
    });
    return keys;
  };

  var getTreeData = function getTreeData(key, nodes, equalObj) {
    if (!nodes || nodes.length === 0) {
      return null;
    }
    var obj = null;
    nodes.every(function (node) {
      if (equalObj && node.data === key || !equalObj && node.key === key) {
        obj = node;
        return false;
      }
      obj = getTreeData(key, node.children, equalObj);
      if (obj) {
        return false;
      }
      return true;
    });
    return obj;
  };

  treeProps = _extends({
    showLine: true,
    defaultExpandAll: true,
    expandedKeys: getTreeKeys(dataSource),
    selectedKeys: [(getTreeData(selectTree, dataSource, true) || {}).key],
    onSelect: function onSelect(keys) {
      if (!keys || keys.length === 0) {
        var obj = getTreeData(selectTree, dataSource, true);
        _onSelect(obj.data, obj);
      } else {
        var _obj = getTreeData(keys[0], dataSource);
        _onSelect(_obj.data, _obj);
      }
    }
  }, treeProps);

  if (treeProps.defaultExpandAll) {
    delete treeProps.expandedKeys;
  }

  var treeStyle = {
    height: '100%',
    overflowY: 'auto'
  };

  if (loading) {
    return _react2.default.createElement(_spin2.default, { spinning: true });
  }

  return dataSource.length === 0 ? _react2.default.createElement(
    'span',
    null,
    '\u6682\u65E0\u6570\u636E'
  ) : _react2.default.createElement(
    _tree2.default,
    _extends({}, treeProps, {
      style: treeStyle
    }),
    genTreeNodes(dataSource)
  );
};

exports.default = DDTree;